SystemOrganization addCategory: #'OmniBrowser-Tests'!
SystemOrganization addCategory: #'OmniBrowser-Fakes'!
SystemOrganization addCategory: #'OmniBrowser-Kernel'!
SystemOrganization addCategory: #'OmniBrowser-Morphs'!
SystemOrganization addCategory: #'OmniBrowser-Nodes'!
SystemOrganization addCategory: #'OmniBrowser-Actors'!
SystemOrganization addCategory: #'OmniBrowser-Notifications'!
SystemOrganization addCategory: #'OmniBrowser-Utilities'!

Object subclass: #OBFakeClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Fakes'!

OBFakeClassA class
	instanceVariableNames: 'foo'!

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/11/2003 20:57'!
three
	^ 3! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 2/9/2004 23:44'!
one
	^ 1! !

!OBFakeClassA class methodsFor: 'capitals' stamp: 'cwp 2/9/2004 19:57'!
b
	^ $B! !

!OBFakeClassA methodsFor: 'letters' stamp: 'cwp 12/10/2003 23:06'!
b
	^ $b! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/10/2003 23:05'!
two
	^ 2! !

!OBFakeClassA methodsFor: 'letters' stamp: 'cwp 2/9/2004 20:05'!
a
	^ $a! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 2/8/2004 13:27'!
five
	^ self two + self three! !

!OBFakeClassA class methodsFor: 'capitals' stamp: 'cwp 2/9/2004 23:44'!
a
	^ $A! !

Object subclass: #OBMetaNode
	instanceVariableNames: 'nodeClass filterClass edges actors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/7/2004 22:44'!
children
	^ edges collect: [:edge | edge metaNode]! !

!OBMetaNode methodsFor: 'filtering' stamp: 'cwp 2/9/2004 21:02'!
filterClass: aClass
	filterClass _ aClass! !

!OBMetaNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 22:38'!
setNodeClass: aNodeClass
	nodeClass _ aNodeClass.
	edges _ OrderedCollection new.
	actors _ OrderedCollection new.! !

!OBMetaNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 17:45'!
for: aNodeClass
	^ self new setNodeClass: aNodeClass! !

!OBMetaNode methodsFor: 'filtering' stamp: 'cwp 2/9/2004 21:26'!
filter
	filterClass ifNil: [filterClass _ OBFilter].
	^ filterClass forMetaNode: self! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 2/9/2004 21:18'!
nodesForParent: aNode
	^ (self ownsNode: aNode)
		ifTrue: [edges gather: [:edge | edge nodesForParent: aNode]]
		ifFalse: [#()]! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/7/2004 22:38'!
hasChildren
	^ edges isEmpty not! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/7/2004 22:35'!
childAt: aSelector put: aMetaNode
	edges add: (OBMetaEdge selector: aSelector metaNode: aMetaNode)! !

!OBMetaNode methodsFor: 'metagraph' stamp: 'cwp 2/9/2004 21:12'!
edges
	^ edges! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/9/2004 21:16'!
childFor: aNode
	^ (edges detect: [:e | e metaNode ownsNode: aNode]) metaNode! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 2/5/2004 20:15'!
actionsForParent: aNode
	^ actors gather: [:actor | actor actionsForParent: aNode]! !

!OBMetaNode methodsFor: 'filtering' stamp: 'cwp 2/9/2004 21:00'!
metaNode
	^ self! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 1/23/2004 23:25'!
actionsForNode: aNode
	^ actors gather: [:actor | actor actionsForNode: aNode]! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 12/18/2003 20:48'!
nodeClass
	^ nodeClass! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 2/9/2004 20:28'!
childAt: aSelector labeled: aString put: aMetaNode
	edges add: (OBMetaEdge label: aString selector: aSelector metaNode: aMetaNode)! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 2/5/2004 20:18'!
addActor: anActor
	anActor attachToMetaNode: self.
	actors add: anActor.! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 2/9/2004 21:15'!
ownsNode: aNode
	^ aNode isMemberOf: nodeClass! !

!OBMetaNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:34'!
on: aNodeClass
	^ self new setNodeClass: aNodeClass! !

Object subclass: #OBFakeClassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Fakes'!

Object subclass: #OBBrowser
	instanceVariableNames: 'columns scroller size'
	classVariableNames: 'MetaGraphs'
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/23/2003 18:02'!
label
	^ 'OmniBrowser'! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 1/26/2004 21:47'!
currentNode
	^ self currentColumn ifNotNilDo: [:column | column selectedNode]! !

!OBBrowser methodsFor: 'notification' stamp: 'cwp 1/30/2004 00:40'!
nodeCreated: aNode
	self jumpTo: aNode! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 12/17/2003 16:38'!
metaNode: aMetaNode node: aNode
	^ self new setMetaNode: aMetaNode node: aNode! !

!OBBrowser methodsFor: 'testing' stamp: 'cwp 1/31/2004 10:26'!
hasMorphs
	^ scroller notNil! !

!OBBrowser methodsFor: 'navigating' stamp: 'cwp 2/7/2004 15:57'!
root
	^ columns first parent! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 12/18/2003 22:24'!
browseMetaGraphs
	(OBBrowser
		metaNode: OBMetaGraphBuilder default metaGraphBrowser
		node: (OBDictionaryNode on: MetaGraphs)) open! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 1/31/2004 10:21'!
browseFileSystem
	^ self 
		browse: #FileSystem
		fromRoot: (OBDirectoryNode on: FileDirectory root)
		select: (OBDirectoryNode default).
! !

!OBBrowser methodsFor: 'callbacks' stamp: 'cwp 1/26/2004 21:45'!
text
	| node |
	node _ self currentNode.
	^ node 
		ifNil: ['']
		ifNotNil: [node text]! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 18:13'!
removeMetaGraphAt: aSymbol
	MetaGraphs removeKey: aSymbol! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 19:50'!
metaGraphs
	^ MetaGraphs! !

!OBBrowser methodsFor: 'navigating' stamp: 'cwp 2/2/2004 22:31'!
jumpTo: aNode
	| column ancestor |
	column _ columns first.
	[column refresh.
	ancestor _ column selectAncestorOf: aNode.
	ancestor = aNode or: [ancestor isNil]]
		whileFalse: [column _ columns after: column].					
	self updateMorphs! !

!OBBrowser methodsFor: 'accessing' stamp: 'cwp 2/7/2004 23:08'!
size: anInteger
	size _ anInteger! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 1/31/2004 10:25'!
updateMorphs
	self hasMorphs 
		ifTrue: [scroller clearPanes.
				columns do: [:c | scroller addPane: c morph].
				(self minPanes - columns size) timesRepeat: [scroller addPane: self emptyPane].
				scroller doLayout.
				self changed: #text]! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 2/7/2004 23:17'!
browse: aSymbol fromRoot: aNode minPanes: anInteger
	| browser |
	browser _ self metaNode: (MetaGraphs at: aSymbol) node: aNode.
	browser 
		size: anInteger;
		open.
	^ browser! !

!OBBrowser methodsFor: 'initializing' stamp: 'cwp 2/7/2004 23:07'!
setMetaNode: aMetaNode node: aNode
	columns _ OrderedCollection with: (OBColumn 
										inBrowser: self 
										metaNode: aMetaNode
										node: aNode).
	size _ 1! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 1/29/2004 23:51'!
textPane
	^ PluggableTextMorph
		on: self
		text: #text
		accept: #accept:notifying:! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 18:13'!
metaGraphAt: aSymbol put: aMetaGraph
	MetaGraphs at: aSymbol put: aMetaGraph! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/29/2003 17:37'!
window
	| window |
	window _ SystemWindow labelled: self label.
	window model: self.
	window 
		addMorph: self scroller
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.4)).
	window
		addMorph: self textPane
		fullFrame: (LayoutFrame fractions: (0@0.4 corner: 1@1)).
	^ window! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 2/7/2004 23:08'!
minPanes
	^ size! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 2/5/2004 20:00'!
hasFilters
	^ true! !

!OBBrowser methodsFor: 'updating' stamp: 'avi 1/26/2004 13:03'!
selected: aColumn
	| index |
	index _ columns indexOf: aColumn.
	columns _ columns first: index.
	aColumn next ifNotNilDo: [:next | columns add: next].
	self updateMorphs! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 1/31/2004 10:20'!
browse: aSymbol fromRoot: rootNode select: selectedNode
	^ (self metaNode: (MetaGraphs at: aSymbol) node: rootNode) 
		jumpTo: selectedNode;
		open! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 2/7/2004 16:52'!
currentOrRootNode
	^ (columns reversed 
				detect: [:ea | ea selection > 0] 
				ifNone: [^ columns first parent]) selectedNode
! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 12/3/2003 13:46'!
deselected: aColumn
	| index |
	index _ columns indexOf: aColumn.
	columns _ columns first: index.
	self updateMorphs! !

!OBBrowser methodsFor: 'callbacks' stamp: 'cwp 1/30/2004 00:51'!
accept: aText notifying: aController
	| column |
	column _ self currentColumn ifNil: [^ self].
	[column accept: aText notifying: aController]
		on: OBNotification
		do: [:notification | notification notify: self].
	self changed: #text.! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/8/2003 20:25'!
scroller
	^ scroller ifNil: [scroller _ OBPaneScroller new.
					scroller 
						name: 'scroller';
						vResizing: #spaceFill;
						hResizing: #spaceFill.
					self updateMorphs.
					scroller]
	! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 2/8/2004 01:41'!
browsePackages
	^ self 
		browse: #System
		fromRoot: (OBSystemNode on: OBImageContext new)
		minPanes: 5! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 2/7/2004 23:14'!
browsePackage: aString
	^ self 
		browse: #Package 
		fromRoot: (OBPackageNode on: (OBPackageContext named: aString))
		minPanes: 4! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 2/9/2004 19:40'!
browseImage
	^ self 
		browse: #Image
		fromRoot: (OBSystemNode on: OBImageContext new)
		minPanes: 4
! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/8/2003 20:21'!
emptyPane
	^ RectangleMorph new color: Color white! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/10/2003 22:51'!
open
	^ self window openInWorld! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 1/26/2004 21:46'!
currentColumn
	^ columns reversed detect: [:ea | ea selection > 0] ifNone: []
! !

!OBBrowser class methodsFor: 'initialize-release' stamp: 'cwp 12/18/2003 18:11'!
initialize
	MetaGraphs _ Dictionary new! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 19:45'!
metaGraphAt: aSymbol
	^ MetaGraphs at: aSymbol! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 2/7/2004 23:16'!
browse: aSymbol fromRoot: aNode
	| browser |
	browser _ self metaNode: (MetaGraphs at: aSymbol) node: aNode.
	browser open.
	^ browser
! !

Object subclass: #OBNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:57'!
hash
	^ self name hash! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:20'!
accept: aText notifying: aController
	self text: aText! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:57'!
= other
	^ self class = other class and: [self name = other name]! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/10/2003 22:27'!
name
	self subclassResponsibility! !

OBNode subclass: #OBClassCreatingNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

OBClassCreatingNode subclass: #OBClassCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassCategoryNode methodsFor: 'class creation' stamp: 'cwp 1/29/2004 23:43'!
subclassDefiner
	^ nil subclassDefinerClass! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 2/2/2004 21:46'!
isAncestorOf: aNode
	^ aNode classCategoryNode name = name
! !

!OBClassCategoryNode class methodsFor: 'instance creation' stamp: 'cwp 12/10/2003 23:17'!
on: aString inContext: aCodeContext
	^ self new setName: aString context: aCodeContext! !

!OBClassCategoryNode methodsFor: 'navigation' stamp: 'cwp 2/2/2004 21:47'!
classCategoryNode
	^ self! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 12/17/2003 18:16'!
classes
	^ (context classesInCategory: name) 
		collect: [:class | OBClassNode on: class inContext: context]! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 2/7/2004 20:53'!
metaclasses
	^ (context classesInCategory: name) 
		collect: [:class | OBMetaclassNode on: class inContext: context]! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'cwp 2/5/2004 20:34'!
actionsForParent: aNode
	^ Array
		with: (OBAction 
				label: 'create category...'
				receiver: self
				selector: #createInContext:
				arguments: (Array with: aNode context))
		! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/3/2004 22:40'!
remove
	context removeCategory: name.
	OBNodeDeleted new signal.! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 1/29/2004 23:06'!
text
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', (context longNameOf: name), ''''! !

!OBClassCategoryNode class methodsFor: 'actions' stamp: 'cwp 2/7/2004 10:28'!
createInContext: aContext
	| catName |
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: 'Category-Name'.
	catName ifNotNil:	[aContext addCategory: catName.
						(OBNodeSelected for: (OBClassCategoryNode 
												on: catName 
												inContext: aContext))	signal]! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:18'!
name
	^ name! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/5/2004 20:32'!
rename
	| category |
	category _ OBTextRequest
				prompt: 'Please type new category name' 
				template: name.
	category ifNotNil:	[context renameCategory: name toBe: category.
						name _ category.
						OBListChanged new signal]! !

!OBClassCategoryNode methodsFor: 'initializing' stamp: 'cwp 12/14/2003 21:08'!
setName: aString context: aCodeContext
	name _ aString.
	context _ aCodeContext.
! !

!OBClassCategoryNode methodsFor: 'actions' stamp: 'cwp 2/5/2004 20:20'!
actions
	^ Array
		with: (self action: #remove withLabel: 'remove')
		with: (self action: #rename withLabel: 'rename...')! !

OBClassCreatingNode subclass: #OBClassNode
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/9/2004 20:13'!
theClass
	^ context classNamed: className! !

!OBClassNode methodsFor: 'nodes' stamp: 'cwp 2/7/2004 15:08'!
classCategoryNode
	^ OBClassCategoryNode on: (context categoryOf: className) inContext: context! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:10'!
name
	^ className asString! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 17:02'!
symbol
	^ className! !

!OBClassNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:15'!
on: className inContext: aCodeContext
	^ self new setClassName: className context: aCodeContext! !

OBClassNode subclass: #OBMetaclassNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:33'!
name 
	^ self nonMetaName! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 20:13'!
theClass
	^ super theClass class! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:32'!
nonMetaName
	^ (className allButLast: 6) asSymbol! !

!OBMetaclassNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 21:24'!
setClassName: aSymbol context: aCodeContext
	super 
		setClassName: (aSymbol, ' class') asSymbol
		context: aCodeContext! !

!OBClassNode methodsFor: 'nodes' stamp: 'cwp 1/30/2004 01:01'!
classNode 
	^ self! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 15:11'!
rename
	| newName |
	newName _ OBTextRequest
				prompt: 'Please type new class name' 
				template: className asString.
	newName ifNotNil:	[context renameClass: className toBe: newName asSymbol.
						(OBNodeSelected for: self) signal]! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 15:05'!
remove
	context removeClass: className.
	OBNodeDeleted signal.! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:08'!
text
	^ self theClass definition! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:09'!
isAncestorOf: aNode
	^ aNode classNode name asSymbol = className! !

!OBClassNode methodsFor: 'actions' stamp: 'cwp 2/5/2004 23:52'!
actions
	^ Array
		with: (self action: #rename withLabel: 'rename...')
		with: (self action: #remove withLabel: 'remove')! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 2/7/2004 21:19'!
categories
	^ (context coreCategoriesForClass: className)
		collect: [:cat | OBMethodCategoryNode on: cat inClass: className inContext: context]! !

!OBClassNode methodsFor: 'class creation' stamp: 'cwp 2/7/2004 15:09'!
subclassDefiner
	^ self theClass superclass subclassDefinerClass! !

!OBClassNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 15:06'!
setClassName: aSymbol context: aCodeContext
	className _ aSymbol.
	context _ aCodeContext! !

!OBClassCreatingNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:18'!
context
	^ context! !

!OBClassCreatingNode methodsFor: 'class creation' stamp: 'cwp 2/7/2004 21:08'!
defineClass: definition notifying: aController
	| newClass |
	newClass _ self subclassDefiner 
					evaluate: definition 
					notifying: aController
					logged: true.
	newClass isMeta ifFalse: [(OBNodeSelected for: (OBClassNode 
													on: newClass name 
													inContext: context)) signal].
	
! !

!OBClassCreatingNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:32'!
accept: definition notifying: aController
	self defineClass: definition notifying: aController! !

!OBNode methodsFor: 'utility' stamp: 'cwp 2/3/2004 22:29'!
action: aSelector withLabel: aString
	^ OBAction
		label: aString
		receiver: self
		selector: aSelector
		arguments: #()! !

OBNode subclass: #OBPackageNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:52'!
categories
	^ context categories collect: [:cat | OBClassCategoryNode on: cat inContext: context]! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:53'!
package
	^ context package! !

!OBPackageNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:58'!
on: aPackage
	^ self new context: (OBPackageContext on: aPackage)! !

!OBPackageNode methodsFor: 'public' stamp: 'cwp 2/7/2004 14:02'!
isAncestorOf: aNode
	^ context package packageName = aNode context package packageName! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:52'!
classes
	^ context classes collect: [:class | OBClassNode on: class inContext: context]! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:49'!
context
	^ context! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 13:50'!
context: aCodeContext
	context _ aCodeContext! !

!OBPackageNode methodsFor: 'public' stamp: 'cwp 2/7/2004 13:49'!
name
	^ context package packageName! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:23'!
text: aText
	! !

OBNode subclass: #OBDictionaryNode
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBDictionaryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:01'!
on: aDictionary
	^ self new dictionary: aDictionary! !

!OBDictionaryNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:13'!
associations
	^ dictionary keys asArray 
		collect: [:key | OBAssociationNode key: key value: (dictionary at: key)]! !

!OBDictionaryNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:00'!
dictionary: aDictionary
	dictionary _ aDictionary! !

OBNode subclass: #OBAssociationNode
	instanceVariableNames: 'key value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBAssociationNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:14'!
key: keyObject value: valueObject
	^ self new setKey: keyObject value: valueObject! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:15'!
name
	^ key! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:13'!
value
	^ value! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:10'!
setKey: keyObject value: valueObject
	key _ keyObject.
	value _ valueObject.! !

OBNode subclass: #OBFakeNode
	instanceVariableNames: 'item parent children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeNode methodsFor: 'public' stamp: 'cwp 1/23/2004 21:42'!
children
	^ children 
		ifNil: [children _ (self item endsWith: 'c')
					ifTrue: [Array new]
					ifFalse: [#($a $b $c) collect: [:i | OBFakeNode parent: self item: i asString]]]! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 1/23/2004 21:47'!
removeChild: aFakeNode
	children _ children copyWithout: aFakeNode! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 1/23/2004 21:50'!
delete
	parent ifNotNil: [parent removeChild: self].
	OBNodeDeleted new signal.	! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 2/3/2004 22:30'!
actions
	^ Array 
		with: (self action: #beZ withLabel: 'become z')
		with: (self action: #delete withLabel: 'delete')! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:09'!
item: aSymbol
	item _ aSymbol! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:05'!
name
	^ self parentName, self item ! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:04'!
parentName
	^ (parent ifNil: [''] ifNotNil: [parent name])! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:04'!
text: aText
	self item:( aText asString allButFirst: (self parentName size))! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 1/7/2004 09:29'!
beZ
	item _ 'z'! !

!OBFakeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:31'!
metaGraph
	| fake |
	fake _ OBMetaNode for: OBFakeNode.
	fake 
		childAt: #children put: fake;
		addActor: OBNodeActor new.
	^ fake! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:18'!
item
	^ item ifNil: [item _ '']! !

!OBFakeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 22:06'!
parent: aFakeNode item: aString
	^ self new parent: aFakeNode; item: aString! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:03'!
text
	^ self name! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:01'!
parent: aFakeNode
	parent _ aFakeNode! !

OBNode subclass: #OBFileNode
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:20'!
text: aText
	| file |
	file _ self openFile.
	file
		reset;
		nextPutAll: aText asString;
		truncate: (file position);
		close! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:21'!
openFile
	^ FileStream oldFileNamed: path! !

!OBFileNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:58'!
hash
	^ self path hash! !

!OBFileNode methodsFor: 'actions' stamp: 'cwp 1/23/2004 23:14'!
delete
	FileDirectory deleteFilePath: path.
	OBNodeDeleted new signal.	! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/7/2003 20:00'!
name
	^ FileDirectory localNameFor: path! !

!OBFileNode class methodsFor: 'instance creation' stamp: 'cwp 12/7/2003 19:43'!
on: aPath
	^ self new path: aPath! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 12/7/2003 19:44'!
path: aPath
	path _ aPath! !

!OBFileNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:58'!
= other
	^ self path = other path! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 1/24/2004 00:16'!
path
	^ path! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 2/3/2004 22:30'!
actions
	^ Array with: (self action: #delete withLabel: 'delete')! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 1/23/2004 22:55'!
text
	| file text |
	file _ self openFile.
	text _ file contentsOfEntireFile.
	file close.
	^ text! !

OBNode subclass: #OBMetaNodeNode
	instanceVariableNames: 'metaNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:32'!
metaNode: aMetaNode
	metaNode _ aMetaNode! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:15'!
children
	^ metaNode children collect: [:mn | OBMetaNodeNode on: mn]! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:58'!
name
	^ metaNode nodeClass name! !

!OBMetaNodeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:15'!
on: aMetaNode
	^ self new metaNode: aMetaNode! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:26'!
text
	^ 'OBMetaNode on: ', metaNode nodeClass name! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/30/2004 00:52'!
isAncestorOf: aNode
	^ false! !

OBNode subclass: #OBSystemNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:22'!
packages
	^ context packages collect: [:aPackage | OBPackageNode on: aPackage]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:58'!
context
	^ context! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:26'!
categories
	^ context categories collect: [:cat | OBClassCategoryNode on: cat inContext: context]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 06:21'!
name 
	^ 'Squeak'! !

!OBSystemNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:19'!
on: aCodeContext
	^ self new context: aCodeContext! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:18'!
context: aCodeContext
	context _ aCodeContext! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:27'!
text
	^ ''! !

!OBNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:11'!
fromAssociation: anAssociationNode
	^ self on: anAssociationNode value! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/7/2004 09:25'!
actions
	^ #()! !

OBNode subclass: #OBMethodCreatingNode
	instanceVariableNames: 'className context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodCreatingNode methodsFor: 'navigation' stamp: 'cwp 2/7/2004 15:20'!
classCategoryNode
	^ OBClassCategoryNode on: (context categoryOf: className) inContext: context! !

!OBMethodCreatingNode methodsFor: 'method creation' stamp: 'cwp 2/7/2004 15:20'!
methodNodeFor: aSelector
	^ OBMethodNode 
		on: (self referenceForMethod: aSelector ofClass: className)
		inContext: context! !

!OBMethodCreatingNode methodsFor: 'public' stamp: 'cwp 2/9/2004 20:14'!
theClass
	^ context classNamed: className! !

OBMethodCreatingNode subclass: #OBMethodNode
	instanceVariableNames: 'selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 2/8/2004 13:12'!
setReference: aMethodReference context: aCodeContext
	className _ aMethodReference classSymbol.
	aMethodReference classIsMeta ifTrue: [className _ (className, ' class') asSymbol].
	self 
		setSelector: aMethodReference methodSymbol
		class: className
		context: aCodeContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:00'!
chaseSenders
	OBBrowser browse: #ChaseSenders fromRoot: self! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/8/2004 12:59'!
implementors
	^ (context allImplementorsOf: selector) 
			collect: [:ref | OBNakedMethodNode on: ref inContext: context]! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 19:04'!
remove
	context removeMethod: selector fromClass: className.
	OBNodeDeleted signal! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 1/31/2004 00:50'!
isAncestorOf: aNode
	^ self class = aNode class and: [self name = aNode name]! !

!OBMethodNode methodsFor: 'public' stamp: 'cwp 1/31/2004 09:53'!
name
	^ selector! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/8/2004 14:25'!
selector
	^ selector! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:21'!
category
	^ context methodCategoryOf: self reference! !

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 16:02'!
setSelector: aSelector class: aSymbol context: aCodeContext
	className _ aSymbol.
	selector _ aSelector.
	context _ aCodeContext! !

!OBMethodNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 16:03'!
on: aSelector inClass: aSymbol inContext: aCodeContext
	^ self new setSelector: aSelector class: aSymbol context: aCodeContext! !

OBMethodNode subclass: #OBNakedMethodNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBNakedMethodNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:13'!
name
	^ className, '>>', selector ! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:09'!
browseImplementors
	OBBrowser browse: #Implementors fromRoot: self selectMessage! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:39'!
selectMessage
	| messages |
	messages _ (context messagesSentBy: selector inClass: className) copyWithFirst: selector.
	selector _ (OBChoiceRequest options: messages).
	^ OBSelectorNode on: selector inContext: context! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/8/2004 13:40'!
messages
	^ ((context messagesSentBy: selector inClass: className)
		collect: [:sel | OBSelectorNode on: sel inContext: context]) 
			copyWith: self selectorNode! !

!OBMethodNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:51'!
on: aMethodReference inContext: aCodeContext
	^ self new setReference: aMethodReference context: aCodeContext! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:02'!
actions
	^ Array
		with: (self action: #remove withLabel: 'remove')
		with: (self action: #browseImplementors withLabel: 'browse implementors...')
		with: (self action: #browseSenders withLabel: 'browse senders...')
		with: (self action: #chaseImplementors withLabel: 'chase implementors')
		with: (self action: #chaseSenders withLabel: 'chase senders')! !

!OBMethodNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:21'!
text
	^ self reference source! !

!OBMethodNode methodsFor: 'navigating' stamp: 'cwp 2/7/2004 15:21'!
methodCategoryNode
	^ OBMethodCategoryNode 
		on: self category
		inClass: className
		inContext: context! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:09'!
browseSenders
	OBBrowser browse: #Senders fromRoot: self selectMessage! !

!OBMethodNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:20'!
reference
	^ self referenceForMethod: selector ofClass: className! !

!OBMethodNode methodsFor: 'comparing' stamp: 'cwp 2/8/2004 14:26'!
= other
	^ (other isKindOf: OBMethodNode)
		and: [self className = self className] 
		and: [self selector = other selector]! !

!OBMethodNode methodsFor: 'actions' stamp: 'cwp 2/9/2004 23:00'!
chaseImplementors
	OBBrowser browse: #ChaseImplementors fromRoot: self! !

!OBMethodNode methodsFor: 'nodes' stamp: 'cwp 2/8/2004 13:41'!
selectorNode
	^ OBSelectorNode on: selector inContext: context! !

!OBMethodCreatingNode methodsFor: 'method creation' stamp: 'cwp 2/7/2004 15:17'!
compileMethod: aText notifying: aController
	| selector |
	selector _ self theClass compile: aText asString classified: self category notifying: aController.
	selector ifNotNil: [(OBNodeSelected for: (self methodNodeFor: selector)) signal]! !

OBMethodCreatingNode subclass: #OBMethodCategoryNode
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:16'!
on: aString inClass: className inContext: aCodeContext
	^ self new setName: aString class: className context: aCodeContext! !

!OBMethodCategoryNode methodsFor: 'initializing' stamp: 'cwp 2/7/2004 15:28'!
setName: aString class: aSymbol context: aCodeContext
	name _ aString.
	className _ aSymbol.
	context _ aCodeContext! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 15:29'!
rename
	| category |
	category _ OBTextRequest
				prompt: 'Please type new category name' 
				template: name.
	category ifNotNil:	[context renameCategory: name inClass: className toBe: category.
						name _ category.
						OBListChanged new signal]! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 10:59'!
actions
	^ Array
		with: (self action: #remove withLabel: 'remove')
		with: (self action: #rename withLabel: 'rename...')! !

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 17:02'!
createInClass: aClassNode
	| catName |
	catName _ OBTextRequest 
					prompt: 'Please type new category name' 
					template: ''.
	catName ifNotNil:	[aClassNode context addCategory: catName toClass: aClassNode name.
						(OBNodeSelected for: (OBMethodCategoryNode 
												on: catName 
												inClass: aClassNode symbol
												inContext: aClassNode context)) signal]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 1/30/2004 23:45'!
text
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:27'!
methodReferences
	^ context methodsInCategory: name ofClass: className! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:10'!
name
	^ name! !

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 1/31/2004 09:52'!
category
	^ name! !

!OBMethodCategoryNode methodsFor: 'actions' stamp: 'cwp 2/7/2004 15:52'!
remove
	context removeCategory: name fromClass: className.
	OBNodeDeleted signal! !

!OBMethodCategoryNode methodsFor: 'children' stamp: 'cwp 12/17/2003 18:25'!
methods
	^ self methodReferences collect: [:ref | OBMethodNode on: ref inContext: context]! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 2/7/2004 15:28'!
isAncestorOf: aNode
	^ className = aNode classNode name asSymbol
		and: [name = aNode methodCategoryNode name]! !

!OBMethodCategoryNode methodsFor: 'navigation' stamp: 'cwp 2/7/2004 16:13'!
methodCategoryNode
	^ self! !

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:34'!
actionsForParent: aNode
	^ Array with: (OBAction
					label: 'create category...'
					receiver: self
					selector: #createInClass:
					arguments: (Array with: aNode))! !

!OBMethodCreatingNode methodsFor: 'public' stamp: 'cwp 1/31/2004 14:18'!
context
	^ context! !

!OBMethodCreatingNode methodsFor: 'navigation' stamp: 'cwp 2/7/2004 16:12'!
classNode
	^ OBClassNode on: className inContext: context! !

!OBMethodCreatingNode methodsFor: 'public' stamp: 'cwp 1/31/2004 09:51'!
accept: aText notifying: aController
	self compileMethod: aText notifying: aController
	! !

!OBNode methodsFor: 'utility' stamp: 'cwp 2/7/2004 21:29'!
referenceForMethod: selector ofClass: className
	| classIsMeta symbol |
	classIsMeta _ className endsWith: ' class'.
	symbol _ classIsMeta ifTrue: [(className allButLast: 6) asSymbol] ifFalse: [className].
	^ MethodReference new 
		setClassSymbol: symbol
		classIsMeta: classIsMeta
		methodSymbol: selector
		stringVersion: symbol, '>>', selector! !

!OBNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:25'!
actionsForParent: aNode
	^ #()! !

OBNode subclass: #OBDirectoryNode
	instanceVariableNames: 'directory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:51'!
name
	^ directory localName! !

!OBDirectoryNode methodsFor: 'accessing' stamp: 'cwp 1/31/2004 10:15'!
path
	^ directory fullName! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/15/2003 21:37'!
nodeForEntry: anEntry
	^ (anEntry at: 4)
		ifTrue: [OBDirectoryNode on: (directory directoryNamed: (anEntry at: 1))]
		ifFalse: [OBFileNode on: (directory fullNameFor: (anEntry at: 1))]! !

!OBDirectoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 21:57'!
on: aFileDirectory
	^ self new directory: aFileDirectory! !

!OBDirectoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 10:17'!
default
	^ self on: (FileDirectory default)! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 17:43'!
textForDirectory: aFilename
	| entry |
	entry _ directory entryAt: aFilename.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: aFilename); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 11/28/2003 21:57'!
directory: aFileDirectory
	directory _ aFileDirectory! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 1/31/2004 15:15'!
shouldDisplay: name
	^ name first ~= $.! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 18:01'!
displayEntry: entry on: aStream
	aStream nextPutAll: (entry at: 1).
	aStream nextPutAll: ' - '.
	aStream nextPutAll: (entry at: 5) asString, ' bytes'.
	aStream cr.! !

!OBDirectoryNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:59'!
hash
	^ self path hash! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 1/31/2004 15:14'!
files
	^ directory fileNames 
		select: [:name | self shouldDisplay: name]
		thenCollect: [:name | OBFileNode on: (directory fullNameFor: name)]
	! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 1/31/2004 10:14'!
isAncestorOf: aNode
	^ aNode path beginsWith: self path! !

!OBDirectoryNode methodsFor: 'comparing' stamp: 'cwp 1/31/2004 14:59'!
= other
	^ self path = other path! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 1/31/2004 15:14'!
directories
	^ directory directoryNames 
		select: [:name | self shouldDisplay: name]
		thenCollect: [:name | OBDirectoryNode on: (directory directoryNamed: name)]
	! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:47'!
text
	| entry |
	entry _ directory directoryEntry.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: (entry at: 1)); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

OBNode subclass: #OBSelectorNode
	instanceVariableNames: 'selector context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:34'!
name
	^ selector asString! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:00'!
implementors
	^ (context allImplementorsOf: selector) 
			collect: [:ref | OBNakedMethodNode on: ref inContext: context]! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:25'!
setSelector: aSelector context: aCodeContext
	selector _ aSelector.
	context _ aCodeContext.! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:33'!
selector
	^ selector! !

!OBSelectorNode methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:16'!
senders
	^ (context allSendersOf: selector) 
			collect: [:ref | OBNakedMethodNode on: ref inContext: context]! !

!OBSelectorNode class methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:25'!
on: aSelector inContext: aCodeContext
	^ self new setSelector: aSelector context: aCodeContext! !

Object subclass: #OBImageContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 14:48'!
removeCategory: aString fromClass: className 
	(self classNamed: className) organization removeCategory: aString! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/3/2004 22:42'!
removeCategory: aString
	SystemOrganization removeSystemCategory: aString! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 2/7/2004 14:39'!
renameClass: oldName toBe: newName
	Smalltalk renameClassNamed: oldName as: newName! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 1/31/2004 13:29'!
longNameOf: classCategory
	^ classCategory! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 15:32'!
addCategory: aString toClass: className 
	(self classNamed: className asSymbol) organization addCategory: aString! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/9/2004 20:08'!
categoryOf: className
	^ (self classNamed: className) theNonMetaClass category! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 2/7/2004 15:26'!
methodsInCategory: catName ofClass: className
	^ ((self classNamed: className)
		 organization listAtCategoryNamed: catName)
		 	collect: [:sel | self referenceForMethod: sel ofClass: className]! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/2/2004 22:54'!
renameCategory: oldName toBe: newName
	SystemOrganization renameCategory: oldName toBe: newName! !

OBImageContext subclass: #OBPackageContext
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:11'!
classesInCategory: aString
	^ super classesInCategory: (package longNameOf: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:40'!
addCategory: aString
	super addCategory: (package longNameOf: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 14:49'!
categoryOf: className
	^ package shortNameOf: (super categoryOf: className)! !

!OBPackageContext class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:07'!
named: aString
	^ self on: (PackageInfo named: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:44'!
renameCategory: oldName toBe: newName
	super 
		renameCategory: (package longNameOf: oldName)
		toBe: (package longNameOf: newName)! !

!OBPackageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 14:08'!
longNameOf: aString
	^ package longNameOf: aString! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:08'!
package: aPackage
	package _ aPackage! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:33'!
categories
	^ package systemCategories collect: [:cat | package shortNameOf: cat]! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:09'!
package
	^ package! !

!OBPackageContext class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:07'!
on: aPackageInfo
	^ self new package: aPackageInfo! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:45'!
removeCategory: aString
	super removeCategory: (package longNameOf: aString)! !

!OBPackageContext methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 14:54'!
methodsForClass: className
	| class |
	class _ self classNamed: className.
	^ (package coreMethodsForClass: class), (self extensionMethodsForClass: class)! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 14:48'!
renameCategory: oldName inClass: className toBe: newName 
	(self classNamed: className) organization renameCategory: oldName toBe: newName! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/7/2004 14:44'!
classesInCategory: aCategory
	^ SystemOrganization listAtCategoryNamed: aCategory asSymbol! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 12/17/2003 20:50'!
extensionMethodsForClass: aClass
	^ #()! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 2/8/2004 13:18'!
allSendersOf: aSelector
	^ self systemNavigation allCallsOn: aSelector! !

!OBImageContext methodsFor: 'method categories' stamp: 'cwp 2/7/2004 14:47'!
coreCategoriesForClass: className
	^ (self classNamed: className) organization categories! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 21:12'!
metaclassNamed: aSymbol
	^ (self classNamed: aSymbol) class! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 2/7/2004 14:59'!
methodsForClass: className
	^ (self classNamed: className)
		 selectors asArray collect: [:sel | self referenceForMethod: sel ofClass: className]! !

!OBImageContext methodsFor: 'classes' stamp: 'cwp 2/7/2004 14:36'!
removeClass: className
	(self classNamed: className) removeFromSystem.! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 2/7/2004 19:04'!
removeMethod: aSelector fromClass: className
	(self classNamed: className) removeSelector: aSelector! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 2/8/2004 11:41'!
allImplementorsOf: aSelector
	^ self systemNavigation allImplementorsOf: aSelector! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 21:25'!
classNamed: aString
	^ (aString endsWith: ' class')
		ifTrue: [self metaclassNamed: (aString allButLast: 6) asSymbol]
		ifFalse: [Smalltalk at: aString]! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 12/17/2003 20:40'!
categories
	^ SystemOrganization categories! !

!OBImageContext methodsFor: 'packages' stamp: 'cwp 12/17/2003 20:23'!
packages
	^ PackageInfo allPackages! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 2/7/2004 15:02'!
referenceForMethod: selector ofClass: className
	^ MethodReference new 
		setClassSymbol: className
		classIsMeta: false
		methodSymbol: selector
		stringVersion: className, '>>', selector! !

!OBImageContext methodsFor: 'class categories' stamp: 'cwp 2/2/2004 21:17'!
addCategory: aString
	SystemOrganization addCategory: aString! !

!OBImageContext methodsFor: 'navigation' stamp: 'cwp 2/9/2004 22:48'!
messagesSentBy: aSelector inClass: aSymbol
	^ (((self classNamed: aSymbol) compiledMethodAt: aSelector) messages) asArray! !

!OBImageContext methodsFor: 'methods' stamp: 'cwp 1/31/2004 13:40'!
methodCategoryOf: aMethodReference
	^ aMethodReference actualClass organization 
		categoryOfElement: aMethodReference methodSymbol! !

Object subclass: #OBColumn
	instanceVariableNames: 'browser filter parent children selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/9/2004 21:05'!
morph
	^ self filter wantsButton
		ifTrue: [self columnWithHeader]
		ifFalse: [self simpleColumn]	! !

!OBColumn class methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 22:39'!
inBrowser: aBrowser parent: aNode
	^ self new
			browser: aBrowser;
			parent: aNode! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 1/7/2004 08:41'!
listMorph
	^ (PluggableListMorph
		on: self
		list: #list
		selected: #selection
		changeSelected: #selection:
		menu: #menu:
		keystroke: #keystroke:from:)
			borderWidth: 0! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/7/2004 08:39'!
keystroke: aChar from: aMorph! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 12/15/2003 22:46'!
parent: aNode
	parent _ aNode.
	self refresh.! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 2/9/2004 21:06'!
columnWithHeader
	| col bh |
	col _ BorderedMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new.
	
	bh _ self buttonHeight negated.
	col
		addMorph: self listMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@0 corner: 0@bh)).
	col
		addMorph: self filter buttonMorph
		fullFrame: (LayoutFrame fractions: (0@1 corner: 1@1) offsets: (0@bh corner: 0@0)).
		

	^ col! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 11/5/2003 19:01'!
selection
	^ selection ifNil: [0]! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 12/14/2003 21:18'!
browser: aBrowser
	browser _ aBrowser! !

!OBColumn class methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:05'!
inBrowser: aBrowser metaNode: aMetaNode node: aNode
	^ self new
			setBrowser: aBrowser
			metaNode: aMetaNode
			node: aNode! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/9/2004 22:49'!
refresh
	children _ self filter nodesForParent: parent! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/7/2004 23:00'!
clicked
	(self selection = 0)
		ifTrue: [browser deselected: self]
		ifFalse: [browser selected: self]! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 1/31/2004 10:23'!
select: aNode
	self selection: (children indexOf: aNode)! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 01:04'!
listChanged
	self refresh.
	self changed: #list! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/2/2004 21:54'!
selectedNode
	^ children at: self selection ifAbsent: [].! !

!OBColumn methodsFor: 'printing' stamp: 'cwp 2/2/2004 22:18'!
printOn: aStream
	super printOn: aStream.
	self selectedNode ifNotNilDo: [:node | 
								aStream nextPut: $(.
								aStream nextPutAll: node name.
								aStream nextPut: $).]! !

!OBColumn methodsFor: 'initializing' stamp: 'cwp 2/9/2004 21:29'!
setBrowser: aBrowser metaNode: aMetaNode node: aNode
	browser _ aBrowser.
	filter _ aMetaNode filter monitor: self.
	parent _ aNode.
	self refresh! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:59'!
metaNode
	^ self filter metaNode! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 2/5/2004 20:13'!
menu: aMenu
	self actionsForParentNode, self actionsForSelectedNode
		do: [:action | 
			action monitor: self.
			action addItemToMenu: aMenu].
	^ aMenu! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/7/2004 15:56'!
parent
	^ parent! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 00:54'!
notification: aNotification
	aNotification notify: self.! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 00:55'!
nodeDeleted
	"This gets called by OBNodeDelete if an action causes the currently selected to be deleted."

	self refresh.
	self selection: 0.
! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/24/2004 01:03'!
list
	^ children 
		ifNil: [#()]
		ifNotNil: [children collect: [:ea | ea name]]! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/30/2004 00:38'!
accept: aText notifying: aController
	self selectedNode accept: aText notifying: aController.! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 2/2/2004 22:02'!
nodeCreated: aNode
	browser jumpTo: aNode! !

!OBColumn methodsFor: 'actions' stamp: 'cwp 2/9/2004 20:45'!
actionsForParentNode
	^ self filter children gather: [:child | child actionsForParent: parent].	! !

!OBColumn methodsFor: 'actions' stamp: 'cwp 2/9/2004 20:45'!
actionsForSelectedNode
	| node meta |
	node _ children at: self selection ifAbsent: [^ #()].
	meta _ self filter childFor: node.
	^ meta actionsForNode: node	! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:46'!
next
	| nextNode |
	nextNode _ self filter childFor: self selectedNode.
	^ nextNode hasChildren ifTrue:
		[self class 
			inBrowser: browser
			metaNode: nextNode
			node: self selectedNode]! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:15'!
buttonHeight
	^ 20! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 2/9/2004 21:54'!
selectAncestorOf: aNode
	| ancestor |
	ancestor _ self filter selectAncestorOf: aNode withParent: parent.
	ancestor ifNotNil: [self refresh; select: ancestor].
	^ ancestor! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 2/7/2004 22:59'!
selection: anInteger
	selection _ anInteger.
	self clicked.
	self changed: #selection.! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:58'!
filter
	^ filter! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:22'!
simpleColumn
	^ self listMorph! !

Object subclass: #OBMetaEdge
	instanceVariableNames: 'label selector metaNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:36'!
setLabel: aString selector: aSelector metaNode: aMetaNode
	label _ aString.
	selector _ aSelector.
	metaNode _ aMetaNode! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:46'!
nodesForParent: aNode
	^ selector isUnary
		ifTrue: [aNode perform: selector]
		ifFalse: [Array with: (metaNode nodeClass perform: selector with: aNode)]! !

!OBMetaEdge class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:35'!
label: aString selector: aSelector metaNode: aMetaNode
	^ self new setLabel: aString selector: aSelector metaNode: aMetaNode! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:40'!
metaNode
	^ metaNode! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:40'!
selector
	^ selector! !

!OBMetaEdge methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 22:40'!
label
	^ label! !

!OBMetaEdge class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 22:32'!
selector: aSelector metaNode: aMetaNode
	^ self new setLabel: aSelector asString selector: aSelector metaNode: aMetaNode! !

Object subclass: #OBFilter
	instanceVariableNames: 'metaNode monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBFilter class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 20:54'!
forMetaNode: aMetaNode
	^ self new setMetaNode: aMetaNode! !

OBFilter subclass: #OBModalFilter
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBModalFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 22:23'!
selectAncestorOf: aNode withParent: parentNode
	| ancestor |
	1 	to: metaNode edges size 
	  	do: [:i | selection _ i.
			ancestor _ (self nodesForParent: parentNode)
				detect: [:child | child isAncestorOf: aNode] 
				ifNone: [nil].
			ancestor ifNotNil: [^ ancestor]].
	^ nil! !

!OBModalFilter methodsFor: 'selection' stamp: 'cwp 2/9/2004 21:16'!
nodesForParent: aNode
	^ (metaNode ownsNode: aNode)
		ifTrue: [self selectedEdge nodesForParent: aNode]
		ifFalse: [#()]! !

!OBModalFilter methodsFor: 'selection' stamp: 'cwp 2/9/2004 21:10'!
selection
	^ selection ifNil: [selection _ 1]! !

!OBModalFilter methodsFor: 'morphs' stamp: 'cwp 2/9/2004 21:08'!
buttonMorph
	^ (PluggableButtonMorph 
			on: self 
			getState: #buttonState 
			action: #buttonPushed
			label: #buttonLabel
			menu: nil)
				onColor: Color white darker darker offColor: Color white darker;
				borderWidth: 2;
				borderRaised;
				hResizing: #spaceFill;
				vResizing: #spaceFill! !

!OBModalFilter methodsFor: 'selection' stamp: 'cwp 2/9/2004 21:11'!
selectedEdge
	^ metaNode edges at: self selection ! !

!OBModalFilter methodsFor: 'callbacks' stamp: 'cwp 2/9/2004 21:23'!
buttonState
	^ true! !

!OBModalFilter methodsFor: 'queries' stamp: 'cwp 2/9/2004 21:08'!
wantsButton
	^ true! !

!OBModalFilter methodsFor: 'callbacks' stamp: 'cwp 2/9/2004 21:23'!
buttonPushed
	self incrementSelection.
	self changed: #buttonLabel.
	monitor listChanged.
	monitor clicked.! !

!OBModalFilter methodsFor: 'callbacks' stamp: 'cwp 2/9/2004 21:21'!
buttonLabel
	^ self selectedEdge label! !

!OBModalFilter methodsFor: 'selection' stamp: 'cwp 2/9/2004 21:11'!
incrementSelection
	selection _ selection + 1.
	(selection > metaNode edges size) ifTrue: [selection _ 1].! !

!OBFilter methodsFor: 'queries' stamp: 'cwp 2/9/2004 21:06'!
wantsButton
	^ false! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 20:52'!
nodesForParent: aNode
	^ metaNode nodesForParent: aNode! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 20:51'!
childFor: aNode
	^ metaNode childFor: aNode! !

!OBFilter methodsFor: 'accessing' stamp: 'cwp 2/9/2004 20:56'!
monitor: aMonitor
	monitor _ aMonitor! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 20:50'!
children
	^ metaNode children! !

!OBFilter methodsFor: 'initalizing' stamp: 'cwp 2/9/2004 20:54'!
setMetaNode: aMetaNode
	metaNode _ aMetaNode! !

!OBFilter methodsFor: 'public' stamp: 'cwp 2/9/2004 22:21'!
selectAncestorOf: aNode withParent: parentNode
	^ (metaNode nodesForParent: parentNode)
		detect: [:child | child isAncestorOf: aNode] 
		ifNone: [nil]! !

Object subclass: #OBMetaGraphBuilder
	instanceVariableNames: ''
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBMetaGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:31'!
default
	^ Instance! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 23:07'!
installGraphs
	OBBrowser 
	
		"Code browsers"
		metaGraphAt: #System put: self systemBrowser;
		metaGraphAt: #Image put: self imageBrowser;
		metaGraphAt: #Package put: self packageBrowser;
		metaGraphAt: #Implementors put: self implementorsBrowser;
		metaGraphAt: #Senders put: self sendersBrowser;

		"Experimental chasing browsers"
		metaGraphAt: #ChaseImplementors put: self chaseImplementorsBrowser;
		metaGraphAt: #ChaseSenders put: self chaseSendersBrowser;

		"FileSystem browsers"
		metaGraphAt: #FileSystem put: self fileSystemBrowser
	! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:28'!
imageBrowser
	^ (OBMetaNode for: OBSystemNode)
		childAt: #categories put: self catClassCatMethod! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 22:58'!
sendersBrowser
	| root senders |
	root _ OBMetaNode for: OBSelectorNode.
	senders _ OBMetaNode for: OBNakedMethodNode.
	
	root
		childAt: #senders put: senders;
		addActor: OBNodeActor new.
	senders
		addActor: OBNodeActor new.
		
	^ root! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 22:11'!
metaGraphBrowser
	| dict assoc metaNode |
	dict _ OBMetaNode on: OBDictionaryNode.
	assoc _ OBMetaNode on: OBAssociationNode.
	metaNode _ OBMetaNode on: OBMetaNodeNode.
	
	dict childAt: #associations put: assoc.
	assoc childAt: #fromAssociation: put: metaNode.
	metaNode childAt: #children put: metaNode.

	^ dict ! !

!OBMetaGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:33'!
initialize
	Instance _ self new.
	Instance installGraphs! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 1/24/2004 00:34'!
fileSystemBrowser
	| directory file |
	directory _ OBMetaNode for: OBDirectoryNode.
	file _ OBMetaNode for: OBFileNode.
	file 
		addActor: OBNodeActor new;
		addActor: OBFileRegistryActor new.
	directory 
		childAt: #directories put: directory;
		childAt: #files put: file.
	^ directory! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:28'!
systemBrowser
	^ (OBMetaNode for: OBSystemNode)
		childAt: #packages put: self packageBrowser! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:23'!
packageBrowser
	^ (OBMetaNode for: OBPackageNode)
		childAt: #categories put: self catClassCatMethod
	! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 22:57'!
implementorsBrowser
	| root implementors |
	root _ OBMetaNode for: OBSelectorNode.
	implementors _ OBMetaNode for: OBNakedMethodNode.
	
	root
		childAt: #implementors put: implementors;
		addActor: OBNodeActor new.
	implementors
		addActor: OBNodeActor new.
		
	^ root! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 22:55'!
chaseImplementorsBrowser
	| root messages related |
	root _ OBMetaNode for: OBMethodNode.
	messages _ OBMetaNode for: OBSelectorNode.
	related _ OBMetaNode for: OBNakedMethodNode.
	
	root 
		childAt: #messages put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	messages
		childAt: #implementors put: related;
		childAt: #senders put: related;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	related
		childAt: #messages put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
		
	^ root! !

!OBMetaGraphBuilder methodsFor: 'private' stamp: 'cwp 2/9/2004 21:19'!
catClassCatMethod
	| classCategory class methodCategory method metaclass |
	classCategory _ OBMetaNode for: OBClassCategoryNode.
	class _ OBMetaNode for: OBClassNode.
	metaclass _ OBMetaNode for: OBMetaclassNode.
	methodCategory _ OBMetaNode for: OBMethodCategoryNode.
	method _ OBMetaNode for: OBMethodNode.

	classCategory 
		childAt: #classes labeled: 'instance' put: class;
		childAt: #metaclasses labeled: 'class' put: metaclass;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	class 
		childAt: #categories put: methodCategory;
		addActor: OBNodeActor new.
	metaclass
		childAt: #categories put: methodCategory.
	methodCategory 
		childAt: #methods put: method;
		addActor: OBNodeActor new.
	method 
		addActor: OBNodeActor new.
	
	^ classCategory! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 2/9/2004 22:56'!
chaseSendersBrowser
	| root messages related |
	root _ OBMetaNode for: OBMethodNode.
	messages _ OBMetaNode for: OBSelectorNode.
	related _ OBMetaNode for: OBNakedMethodNode.
	
	root 
		childAt: #messages put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	messages
		childAt: #senders put: related;
		childAt: #implementors put: related;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
	related
		childAt: #messages put: messages;
		addActor: OBNodeActor new;
		filterClass: OBModalFilter.
		
	^ root! !

Object subclass: #OBActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:12'!
actionsForParent: aNode
	^#()! !

!OBActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/4/2004 15:25'!
actionsForNode: aNode
	^#()! !

!OBActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:19'!
attachToMetaNode: aMetaNode
	! !

OBActor subclass: #OBFileRegistryActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Actors'!

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:34'!
updateFileList
	OBListChanged new signal! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:05'!
update: aParameter
	(aParameter == #fileListChanged) ifTrue: [self updateFileList].
	super update: aParameter! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:11'!
actionsForNode: aFileNode
	| services actions |
	services _ FileList itemsForFile: aFileNode path.
	services do: [:svc | svc addDependent: self].
	actions _ services collect: [:s | OBAction
							label: s label
							receiver: s
							selector: s requestSelector
							arguments: (Array with: aFileNode path)].
	^ actions! !

OBActor subclass: #OBNodeActor
	instanceVariableNames: 'nodeClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Actors'!

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:24'!
actionsForNode: aNode
	^ aNode actions! !

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:17'!
actionsForParent: aNode
	^ nodeClass actionsForParent: aNode! !

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:19'!
attachToMetaNode: aMetaNode
	nodeClass _ aMetaNode nodeClass! !

Object subclass: #OBFakeClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Fakes'!

RectangleMorph subclass: #OBPaneScroller
	instanceVariableNames: 'background transform scrollBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 11:10'!
adjustPaneHeight
	"This gets called after the scrollbar has been shown or hidden, to move the bottom
	of the panes to the right place."
	
	transform bounds: self innerBounds.
	transform submorphsDo: [:m | m bounds: (m bounds withHeight: self paneHeight)]
		! !

!OBPaneScroller methodsFor: 'input events' stamp: 'cwp 8/25/2003 20:33'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 21:14'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range _ self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval _ ((self innerBounds width) / self totalScrollRange) asFloat.
	value _ (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 10:53'!
fullLayout
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
	self scrollToRight.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 22:13'!
layoutWidgets
	| inner outer |
	outer _ super innerBounds.
	inner _ self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom + 1)
						corner: outer bottomRight)! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 2/8/2004 01:21'!
panes
	| panes subs |
	subs _ transform submorphs.
	panes _ Array new: (subs size / 2) ceiling.
	1 to: subs size by: 2 do: [:i | panes at: (i / 2) ceiling put: (subs at: i)].
	^ panes! !

!OBPaneScroller methodsFor: 'defaults' stamp: 'cwp 8/24/2003 15:13'!
separatorWidth
	^ 4! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 11:06'!
doLayout
	self layoutWidgets.
	self layoutPanes.
	self hideOrShowScrollBar.
	self setScrollDeltas.
	self scrollToRight.! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 21:04'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 10:42'!
isScrollable
	^ self leftoverScrollRange > 0! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/23/2003 16:21'!
scrollDeltaWidth
	^ 1! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:07'!
paneCount
	^ (transform submorphs size / 2) ceiling.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 00:43'!
totalPaneWidth
	^ self innerBounds width - (self separatorCount * self separatorWidth)! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 8/24/2003 15:15'!
separator
	^ BorderedSubpaneDividerMorph vertical 
		borderWidth: self separatorWidth / 2;
		color: Color lightGray;
		borderRaised.! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 19:27'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 11:10'!
hideScrollBar
	self removeMorph: scrollBar.
	self adjustPaneHeight.! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 2/8/2004 10:52'!
initializeTransform
	transform _ TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout;
		bounds: super innerBounds.
	self addMorphBack: transform.
! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 12/6/2003 17:06'!
clearPanes
	transform removeAllMorphs! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 8/25/2003 21:24'!
initialize
	super initialize.
	self 
		color: Color red;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 21:20'!
bounds: aRectangle
	super bounds: aRectangle.
	self doLayout.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/24/2003 14:29'!
scrollBarHeight
	^ 12! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:08'!
paneHeight
	^ transform bounds height! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 12/6/2003 17:05'!
addPane: aMorph
	aMorph 
		borderWidth: 0;
		hResizing: #rigid;
		vResizing: #rigid;
		layoutInset: 0.
	transform hasSubmorphs ifTrue: [transform addMorphBack: self separator].
	transform addMorphBack: aMorph! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 10:54'!
innerBounds
	| rect |
	rect _ super innerBounds.
	^ self scrollBarIsVisible
		ifTrue: [rect withHeight: rect height - self scrollBarHeight - 1]
		ifFalse: [rect]! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 12/8/2003 21:42'!
scrollToRight
	^ scrollBar setValue: 1.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 01:22'!
layoutPanes
	| widths rect |
	widths _ self computeMorphWidths.
	rect _ 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect _ rect withWidth: w.
						m bounds: rect.
						rect _ rect translateBy: (w@0)]
						
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 10:56'!
scrollBarIsVisible
	^ submorphs includes: scrollBar! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 00:53'!
separatorCount
	^ self paneCount - 1! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 11:11'!
showScrollBar
	self scrollBarIsVisible ifTrue: [^ self].
	self resizeScrollBar.
	self addMorphFront: scrollBar.
	self adjustPaneHeight.
	! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 01:50'!
padWidths: widths toFit: limit
	| total padded |
	total _ widths sum.
	total > limit ifTrue: [^ widths].
	padded _ Array new: widths size.
	padded atAllPut: (limit / widths size) floor.
	(1 to: limit - padded sum) do: [:i | padded at: i put: (padded at: i) + 1].
	^ padded
	
	! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 11:03'!
resizeScrollBar
	| inner outer |
	outer _ super innerBounds.
	inner _ outer withHeight: outer height - self scrollBarHeight - 1.
	scrollBar bounds: ((inner left @ inner bottom + 1)
						corner: outer bottomRight)! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 2/8/2004 11:01'!
initializeScrollbar
	scrollBar _ OBScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self resizeScrollBar.
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 2/8/2004 10:44'!
hideOrShowScrollBar
	self isScrollable ifTrue: [self showScrollBar] ifFalse: [self hideScrollBar]! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 2/8/2004 00:59'!
computeMorphWidths
	| paneWidths widths |
	paneWidths _ self 
					padWidths: (self panes collect: [:pane | pane idealWidth])
					toFit: self totalPaneWidth.
	widths _ OrderedCollection new.
	paneWidths do: [:w | widths add: w] separatedBy: [widths add: self separatorWidth].
	^ widths asArray
! !

!RectangleMorph methodsFor: '*omnibrowser' stamp: 'cwp 2/8/2004 00:17'!
idealWidth
	^ 100! !

TestResource subclass: #OBDirectoryResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
tearDown
	self dataDir recursiveDelete! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:44'!
dataDirName
	^ 'obtest'! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ FileDirectory default directoryNamed: self dataDirName! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
setUp
	| dir |
	dir _ self dataDir.
	dir assureExistence.
	#(alpha beta gamma) do: [:filename | | file | file _ dir forceNewFileNamed: filename.
							  file nextPutAll: filename.
							  file close].
	dir createDirectory: 'delta'.
	(dir directoryNamed: 'delta') createDirectory: 'epsilon'.! !

TestCase subclass: #OBNodeTest
	instanceVariableNames: 'context notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBNodeTest methodsFor: 'callbacks' stamp: 'cwp 2/2/2004 21:37'!
notification: aNotification
	notification _ aNotification! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 21:26'!
actionWithLabel: aString
	^ self actionFrom: self node withLabel: aString! !

!OBNodeTest methodsFor: 'asserting' stamp: 'cwp 2/5/2004 23:35'!
assertNodeCreated
	self assert: (notification isKindOf: OBNodeSelected)! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 20:30'!
actor
	^ OBNodeActor new attachToMetaNode: self! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 20:29'!
parent
	^ OBPackageNode on: context! !

OBNodeTest subclass: #OBClassCategoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBClassCategoryNodeTest methodsFor: 'callbacks' stamp: 'cwp 2/5/2004 21:53'!
nodeClass
	^ OBClassCategoryNode ! !

!OBClassCategoryNodeTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:14'!
testCreateCategory
	| action |
	action _ self actionWithLabel: 'create category...'.
	[action trigger] on: OBTextRequest do: [:n | n resume: 'OBContext-Quux'].
	self assert: (context categories includes: 'OBContext-Quux').
	self assertNodeCreated.
	self assert: notification node name = 'OBContext-Quux'! !

!OBClassCategoryNodeTest methodsFor: 'running' stamp: 'cwp 2/7/2004 14:16'!
tearDown
	context 
		removeCategory: 'OBContext-Foo';
		removeCategory: 'OBContext-Bar';
		removeCategory: 'OBContext-Quux'! !

!OBClassCategoryNodeTest methodsFor: 'running' stamp: 'cwp 2/7/2004 14:22'!
setUp
	context _ OBPackageContext named: 'OmniBrowserFakes'.
	context 
		addCategory: 'OBContext-Foo';
		addCategory: 'OBContext-Bar'! !

!OBClassCategoryNodeTest methodsFor: 'private' stamp: 'cwp 2/7/2004 14:25'!
node
	^ OBClassCategoryNode on: 'OBContext-Foo' inContext: context! !

!OBClassCategoryNodeTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:14'!
testRemoveCategory
	| action |
	action _ self actionFrom: self removalNode withLabel: 'remove'.
	action trigger.
	self deny: (context categories includes: 'OBContext-Bar').
	! !

!OBClassCategoryNodeTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:26'!
testRenameCategory
	| action |
	action _ self actionWithLabel: 'rename...'.
	[action trigger]
		on: OBTextRequest
		do: [:n | n resume: 'OBContext-Quux'].
	self assert: (context categories includes: 'OBContext-Quux').
	self deny: (context categories includes: 'OBContext-Foo').
	! !

!OBClassCategoryNodeTest methodsFor: 'private' stamp: 'cwp 2/7/2004 14:25'!
removalNode
	^ OBClassCategoryNode on: 'OBContext-Bar' inContext: context! !

OBNodeTest subclass: #OBSelectorNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:37'!
setUp
	context _ OBImageContext new.! !

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:23'!
testSenders
	| node |
	node _ self nodeFor: #two.
	self assert: (node senders includes: (OBNakedMethodNode 
											on: #five 
											inClass: #OBFakeClassA
											inContext: context))
! !

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:37'!
nodeFor: aSelector
	^ OBSelectorNode on: aSelector inContext: context! !

!OBSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 13:20'!
testImplementors
	| node |
	node _ self nodeFor: #five.
	self assert: (node implementors includes: (OBNakedMethodNode
												on: #five
												inClass: #OBFakeClassA
												inContext: context))! !

OBNodeTest subclass: #OBClassNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 23:52'!
testRenameClass
	| action |
	action _ self actionWithLabel: 'rename...'.
	[action trigger]
		on: OBTextRequest
		do: [:n | n resume: 'OBFakeClassE'].
	self assert: (Smalltalk hasClassNamed: 'OBFakeClassE').
	self deny: (Smalltalk hasClassNamed: 'OBFakeClassD').! !

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:38'!
node
	^ OBClassNode on: #OBFakeClassD inContext: context! !

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 23:51'!
testRemoveClass
	| action |
	action _ self actionWithLabel: 'remove'.
	action trigger.
	self deny: (Smalltalk hasClassNamed: 'OBFakeClassD')! !

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 22:01'!
createFakeClassD
	Object subclass: #OBFakeClassD
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'OmniBrowser-Fakes'! !

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 21:57'!
nodeClass
	^ OBClassNode! !

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 23:12'!
tearDown
	Smalltalk at: #OBFakeClassE ifPresent: [:fake | fake removeFromSystem].
	Smalltalk at: #OBFakeClassD ifPresent: [:fake | fake removeFromSystem].! !

!OBClassNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 21:47'!
setUp
	self createFakeClassD.
	context _ OBImageContext new.! !

OBNodeTest subclass: #OBMethodCategoryNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:35'!
parent
	^ OBClassNode on: self fakeClass inContext: context! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:34'!
tearDown
	context 
		removeCategory: 'foo' fromClass: self fakeClass;
		removeCategory: 'quux' fromClass: self fakeClass;
		removeCategory: 'bar' fromClass: self fakeClass! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:51'!
testRenameCategory
	| action |
	action _ self actionWithLabel: 'rename...'.
	[action trigger]
		on: OBTextRequest
		do: [:n | n resume: 'quux'].
	self assert: ((context coreCategoriesForClass: self fakeClass) includes: 'quux').
	self deny: ((context coreCategoriesForClass: self fakeClass) includes: 'foo').
	self assert: (notification isKindOf: OBListChanged)
	! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:13'!
fakeClass
	^ #OBFakeClassB! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 11:31'!
setUp
	context _ OBImageContext new.
	context 
		addCategory: 'foo' toClass: self fakeClass;
		addCategory: 'bar' toClass: self fakeClass.! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:24'!
node
	^ OBMethodCategoryNode on: 'foo' inClass: self fakeClass inContext: context ! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 10:22'!
nodeClass
	^ OBMethodCategoryNode! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 11:29'!
removalNode
	^ OBMethodCategoryNode on: 'bar' inClass: self fakeClass inContext: context.! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:13'!
testCreateCategory
	| action |
	action _ self actionWithLabel: 'create category...'.
	[action trigger] on: OBTextRequest do: [:n | n resume: 'quux'].
	self assert: ((context coreCategoriesForClass: self fakeClass) includes: 'quux').
	self assertNodeCreated.
	self assert: notification node name = 'quux'! !

!OBMethodCategoryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 15:51'!
testRemoveCategory
	| action |
	action _ self actionFrom: self removalNode withLabel: 'remove'.
	action trigger.
	self deny: ((context coreCategoriesForClass: self fakeClass) includes: 'bar').
	self assert: (notification isKindOf: OBNodeDeleted)
	! !

OBNodeTest subclass: #OBMethodNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 18:50'!
tearDown
	OBFakeClassA removeSelector: #four! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 19:00'!
node
	^ OBMethodNode
		on: #four
		inClass: #OBFakeClassA
		inContext: context! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:28'!
nodeInFakeA: aSelector 
	^ OBMethodNode
		on: aSelector
		inClass: #OBFakeClassA
		inContext: context! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 19:06'!
testRemoveMethod
	| action selectors |
	action _ self actionWithLabel: 'remove'.
	action trigger.
	selectors _ (context methodsForClass: #OBFakeClassA)
				collect: [:ref | ref methodSymbol].
	self deny: (selectors includes: #four)! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 12:29'!
nodeFive
	^ self nodeInFakeA: #five! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 14:30'!
testMessages
	self nodeFive messages do: [:node | 
								self assert: (node isKindOf: OBNode).
								self assert: (#(+ two three five) includes: node selector)] ! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 18:56'!
createFour
	OBFakeClassA compile: 'four ^ 4' classified: 'numbers'! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 19:01'!
nodeClass
	^ OBMethodNode! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/8/2004 11:38'!
testImplementors
	self assert: (self node implementors includes: self node)! !

!OBMethodNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 18:49'!
setUp
	self createFour.
	context _ OBImageContext new.! !

!OBNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 22:17'!
isAbstract
	^ self name = #OBNodeTest! !

!OBNodeTest methodsFor: 'private' stamp: 'cwp 2/5/2004 21:26'!
actionFrom: aNode withLabel: aString
	| action actor |
	actor _ self actor.
	action _ ((actor actionsForNode: aNode), (actor actionsForParent: self parent))
		detect: [:a | a label = aString]
		ifNone: [self signalFailure: 'No action with label: ', aString].
	action monitor: self.
	^ action! !

TestCase subclass: #OBDictionaryNodeTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDictionaryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:15'!
setUp
	| dict |
	dict _ Dictionary new.
	dict
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	node _ OBDictionaryNode on: dict! !

!OBDictionaryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:16'!
testNames
	| list |
	list _ node associations collect: [:n | n name].
	self assert: (list includesAllOf: #(one two three))! !

TestCase subclass: #OBFileNodeTest
	instanceVariableNames: 'node notification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 22:06'!
testDelete
	| actions delete |
	actions _ node actions.
	delete _ actions detect: [:a | a label = 'delete'] ifNone: [self signalFailure: 'No delete action'].
	delete monitor: self.
	delete trigger.
	self deny: ((FileDirectory default) fileExists: self dataFile).
	self assert: notification class = OBNodeDeleted

	! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:41'!
testText
	self assert: (node text = 'alpha')! !

!OBFileNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 21:38'!
tearDown
	| file |
	file _ FileStream fileNamed: self dataFile.
	file
		reset;
		nextPutAll: 'alpha';
		truncate: (file position);
		close.! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	node _ OBFileNode on: self dataFile.! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:15'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'alpha'! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
notification: aNotification
	notification _ aNotification! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:41'!
testName
	self assert: node name = 'alpha'! !

TestCase subclass: #OBFileNodeEditTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:30'!
createFile
	| file |
	file _ FileStream newFileNamed: self dataFile.
	file
		nextPutAll: 'omega';
		close.
! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:27'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'omega'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:39'!
testAcceptText
	| file |
	node text: 'foo'.
	file _ FileStream readOnlyFileNamed: self dataFile.
	self assert: file contents = 'foo'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	self createFile.
	node _ OBFileNode on: self dataFile.
	! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:28'!
tearDown
	FileDirectory deleteFilePath: self dataFile! !

TestCase subclass: #OBBrowserTest
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/30/2004 01:20'!
assertCurrentItemIs: aString
	self assert: self currentItem = aString! !

OBBrowserTest subclass: #OBFakeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectA
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectC
	self select: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #().
	self assertTextIs: 'c'! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:13'!
metaGraph
	^ OBFakeNode metaGraph! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 16:44'!
testInitialDisplay
	self assert: self listMorphs size = 1.
	self assertListAt: 1 contains: #(a b c).
	self assertTextIs: ''.
	! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:59'!
testAcceptText
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self setText: 'x'.
	self assertListAt: 1 contains: #(x b c).
	self assertListAt: 2 contains: #(xa xb xc).
	self assertTextIs: 'x'
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:29'!
testDeselectA
	self select: #a.
	self deselect: #a.
	self assertListAt: 1 contains: #(a b c).
	self assert: self listMorphs size = 1.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/8/2003 20:33'!
testPanes
	| scroller |
	self assert: (self morphsOfClass: PluggableListMorph) size = 1.
	self assert: (self morphsOfClass: PluggableTextMorph) size = 1.
	scroller _ self morphNamed: 'scroller'.
	self assert: scroller panes size = model minPanes.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 21:33'!
testDeleteB
	self select: #b.
	self selectMenuItem: 'delete'.
	self assertListAt: 1 contains: #(a c).
	self assert: self listMorphs size = 1.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/23/2003 13:12'!
testCreateWindow
	self assert: (morph isKindOf: SystemWindow).
	self assert: (morph label = 'OmniBrowser').
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/7/2004 08:27'!
testAction
	self select: #a.
	self selectMenuItem:  'become z'.
	self assertListAt: 1 contains:  #(z b c)! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:12'!
node
	^ OBFakeNode new! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getList includesAllOf: anArrayOfStrings]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/31/2004 00:15'!
assertListAt: index contains: items
	| list |
	list _ (self listMorphs 
				at: index 
				ifAbsent: [self signalFailure: 'List ', index asString, ' does not exist']) getList.
	self assert: (list size = items size).
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphsOfClass: aClass
	| found |
	found _ OrderedCollection new.
	morph allMorphsDo: [:m | (m isMemberOf: aClass) ifTrue: [found add: m]].
	^ found! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/23/2004 23:30'!
selectMenuItem: aString
	| item |
	item _ self menuItemNamed: aString.
	item ifNil: [self signalFailure: 'Menu item ''', aString, ''' does not exist.'].
	item doButtonAction! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:07'!
findListContaining: aString
	^ self listMorphs detect: [:m | m getList includes: aString] ifNone: []! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphNamed: aString
	^ morph 
		findDeepSubmorphThat: [:m | m knownName = aString]
		ifAbsent: [self signalFailure: aString, 'not found']! !

!OBBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 16:39'!
setUp
	model _ OBBrowser metaNode: self metaGraph node: self node.
	morph _ model window.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
setText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText;
		accept.
	! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/23/2004 22:35'!
assertMenuContains: aString
	| item |
	item _ self menuItemNamed: aString.
	self assert: item notNil! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/31/2004 13:31'!
assertListAt: index includes: items
	| list |
	list _ (self listMorphs 
				at: index 
				ifAbsent: [self signalFailure: 'List ', index asString, ' does not exist']) getList.
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
textMorph
	^ (self morphsOfClass: PluggableTextMorph) last! !

OBBrowserTest subclass: #OBCodeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:48'!
methodOne
	^ 'one
	^ 1'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/7/2004 16:23'!
selectFakePackage
	! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToNumbers
	self selectFakePackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'numbers' 
					inClass: #OBFakeClassA 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'numbers'.! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:59'!
fakeATemplate
	^ 'Object subclass: #OBFakeClassA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:00'!
fakeClassDDefinition
 ^ 'Object subclass: #OBFakeClassD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToFakes
	self selectFakePackage.
	model jumpTo: (OBClassCategoryNode 
					on: self fakeCategoryName 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: self fakeCategoryName! !

OBCodeBrowserTest subclass: #OBPackageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPackageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:07'!
metaGraph
	^ OBMetaGraphBuilder default packageBrowser ! !

!OBPackageBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/31/2004 13:49'!
selectTestCategory
	self select: self fakeCategoryName! !

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 13:58'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #('Fakes').
	self assertTextIs: ''.
	! !

!OBPackageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:58'!
fakeCategoryName
	^ 'Fakes'! !

!OBPackageBrowserTest methodsFor: 'constants' stamp: 'cwp 2/7/2004 14:27'!
node
	^ OBPackageNode on: OBFakePackage default! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/9/2004 19:57'!
testEditClassMethod
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self switchToClassSide.
	self select: 'capitals'.
	self select: 'a'.
	self setText: self altMethodA.
	self assertAListMatches: #('a' 'b').
	self assertCurrentItemIs: 'a'.
	self assert: $B = OBFakeClassA a! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:51'!
testEditClass
	self selectTestCategory.
	self select: 'OBFakeClassC'.
	self setText: self fakeClassCDefinition.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertCurrentItemIs: #OBFakeClassC.
	self assert: OBFakeClassC instVarNames = #(foo)! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/9/2004 19:59'!
tearDown
	super tearDown.
	Smalltalk removeClassNamed: #OBFakeClassD.
	OBFakeClassA removeSelector: #four.
	self restoreFakeClassC.
	self restoreMethodOne.
	self restoreMethodA! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/8/2004 12:46'!
testEditMethod
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self altMethodOne.
	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: 11 = OBFakeClassA new one! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:11'!
testSelectTests
	self selectTestCategory.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertTextIs: self classTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/8/2004 12:46'!
testCreateMethodFromMethod
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self setText: self methodFour.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 2/9/2004 20:04'!
restoreMethodA
	OBFakeClassA class compile: self methodA! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/9/2004 19:57'!
altMethodA
	^ 'a
	^ $B'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToMethodOne
	self selectFakePackage.
	model jumpTo: (OBMethodNode 
					on: #one 
					inClass: #OBFakeClassA
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'one'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/30/2004 23:59'!
methodFour
	^ 'four
	^ 4'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:07'!
testCreateClassFromClass
	self selectTestCategory.
	self select: 'OBFakeClassC'.
	self setText: self fakeClassDDefinition.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC OBFakeClassD).
	self assertCurrentItemIs: #OBFakeClassD ! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:08'!
testCreateClassFromTemplate
	self selectTestCategory.
	self setText: self fakeClassDDefinition.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC OBFakeClassD).
	self assertCurrentItemIs: #OBFakeClassD ! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/8/2004 12:46'!
testCreateMethodFromTemplate
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self setText: self methodFour.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 13:08'!
isAbstract
	^ self name = #OBCodeBrowserTest! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 1/31/2004 14:47'!
restoreMethodOne
	OBFakeClassA compile: self methodOne! !

OBCodeBrowserTest subclass: #OBImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:13'!
node
	^ OBSystemNode on: OBImageContext new! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:10'!
metaGraph
	^ OBMetaGraphBuilder default imageBrowser! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:58'!
fakeCategoryName
	^ 'OmniBrowser-Fakes'! !

!OBImageBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/31/2004 13:48'!
selectTestCategory
	self select: self fakeCategoryName! !

!OBImageBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:44'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: #('OmniBrowser-Fakes').
	self assertTextIs: ''.
	! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 1/31/2004 14:41'!
restoreFakeClassC
	Compiler evaluate: 'Object subclass: #OBFakeClassC
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:38'!
fakeClassCDefinition
 ^ 'Object subclass: #OBFakeClassC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

OBCodeBrowserTest subclass: #OBSystemBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBSystemBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/31/2004 14:03'!
selectTestCategory
	self selectSequence: #('OmniBrowser' 'Fakes')! !

!OBSystemBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 13:13'!
metaGraph
	^ OBMetaGraphBuilder default systemBrowser! !

!OBSystemBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/7/2004 16:24'!
selectFakePackage
	self select: 'OmniBrowserFakes'! !

!OBSystemBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:30'!
node
	^ OBSystemNode on: OBImageContext new! !

!OBSystemBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:43'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: #('OmniBrowser').
	self assertTextIs: ''.
	! !

!OBSystemBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:07'!
fakeCategoryName
	^ 'Fakes'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:10'!
testSelectOne
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: ((MethodReference class: OBFakeClassA selector: #one) source)! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 2/9/2004 20:00'!
methodA
	^ 'a
	^ $A'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/30/2004 23:44'!
methodTemplate
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:10'!
testSelectNumbers
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self methodTemplate! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:47'!
altMethodOne
	^ 'one
	^ 11'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 16:52'!
testJumpToFakeA
	self selectFakePackage.
	model jumpTo: (OBClassNode 
					on: #OBFakeClassA 
					inContext: model currentOrRootNode context).
	self assertCurrentItemIs: 'OBFakeClassA'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 14:01'!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Fakes'''! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 14:10'!
testSelectFakeA
	self selectTestCategory.
	self select: 'OBFakeClassA'.
	self assertAListIncludes: {self fakeCategoryName}.
	self assertAListIncludes: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertAListIncludes: #('letters' 'numbers').
	self assertTextIs: self fakeATemplate! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 2/9/2004 19:54'!
switchToClassSide
	| button |
	button _ (self morphsOfClass: PluggableButtonMorph) first.
	button performAction! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
deselect: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	listMorph changeModelSelection: 0.! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/31/2004 13:24'!
currentList
	^ self listMorphs reversed detect: [:list | list selection notNil]! !

OBBrowserTest subclass: #OBMetaGraphBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:50'!
node
	^ OBDictionaryNode on: OBBrowser metaGraphs! !

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:22'!
testInitialDisplay
	self listMorphs size = 1.
	self assertAListIncludes: #(System Package Image FileSystem).
	self assertTextIs: ''.
	! !

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:23'!
metaGraph
	^ OBMetaGraphBuilder default metaGraphBrowser! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertTextIs: aString
	self assert: self textMorph text = aString.! !

!OBBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:10'!
isAbstract
	^ self name = 'OBBrowserTest'! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/31/2004 13:23'!
currentItem
	^ self currentList selection! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
select: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	self assert: listMorph notNil.
	listMorph changeModelSelection: (listMorph getList indexOf: aString).! !

OBBrowserTest subclass: #OBDirectoryBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 1/31/2004 10:13'!
epsilonNode
	^ OBFileNode 
		on: ((OBDirectoryResource current dataDir directoryNamed: 'delta') fullNameFor: 'epsilon')! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:19'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: ''.
	! !

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 12/17/2003 15:14'!
node
	^ OBDirectoryNode on: OBDirectoryResource current dataDir! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/31/2004 10:13'!
testJumpToEpsilon
	| node |
	node _ self epsilonNode.
	model jumpTo: node.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertListAt: 2 contains: #(epsilon).
	self assertCurrentItemIs: 'epsilon'.! !

!OBDirectoryBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:09'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryBrowserTest methodsFor: 'constants' stamp: 'cwp 12/18/2003 18:33'!
metaGraph
	^ OBMetaGraphBuilder default fileSystemBrowser! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 17:01'!
testSelectAlpha
	self select: 'alpha'.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: 'alpha'! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 23:33'!
testMenuItems
	self select: 'alpha'.
	self assertMenuContains: 'delete'! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/26/2004 21:53'!
menuItemNamed: aString
	| lists current |
	lists _ self listMorphs.
	current _ lists reversed detect: [:list | list selection notNil].
	^ (current getMenu: true) itemWithWording: aString.
! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/31/2004 14:05'!
selectSequence: aCollection
	| list |
	aCollection do: [:item | 
					list _ self listMorphs last.
					list changeModelSelection: (list getList indexOf: item)]! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertAListMatches: strings
	| listMorphs list |
	listMorphs _ self listMorphs.
	listMorphs 
		detect: [:m | list _ m getList. (list size = strings size) and: [list includesAllOf: strings]]
		ifNone: [self assert: false].! !

TestCase subclass: #OBFileRegistryActorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
assertActions: actions include: required
	| labels |
	labels _ actions collect: [:act | act label].
	self assert: (required includesAllOf: labels)! !

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
testTextFile
	| actor node actions |
	actor _ OBFileRegistryActor new.
	node _ OBFileNode on: (FileDirectory default fullNameFor: 'foo.txt').
	actions _ actor actionsForNode: node.
	self assertActions: actions include: #('add file to new zip' 'compress file').! !

TestCase subclass: #OBDirectoryNodeTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testName
	self assert: node name = 'obtest'! !

!OBDirectoryNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:01'!
testDirectoryNodes
	| children |
	children _ node directories collect: [:n | n name].
	self assert: children = #(delta)
	! !

!OBDirectoryNodeTest methodsFor: 'running' stamp: 'cwp 12/15/2003 21:39'!
setUp
	node _ OBDirectoryNode on: self dataDir.! !

!OBDirectoryNodeTest methodsFor: 'data' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ OBDirectoryResource current dataDir! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testText
	self assert: (node text endsWith: '
----------
alpha - 5 bytes
beta - 4 bytes
delta - 0 bytes
gamma - 5 bytes
')
! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 14:49'!
testFileNodes
	| children |
	children _ node files.
	self assert: (children collect: [:n | n name]) = #(alpha beta gamma)
	! !

TestCase subclass: #OBContextTest
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 14:52'!
fakeASelectors
	^ (context methodsForClass: #OBFakeClassA)
		collect: [:ref | ref methodSymbol]! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:49'!
testMethodsForClass
	self assert: (self fakeASelectors includesAllOf: self fakeACoreSelectors).
	self deny: (self fakeASelectors includesAnyOf: self fakeAExtensionSelectors).! !

!OBContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 11:45'!
fakeCategory
	^ 'OmniBrowser-Fakes'! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 13:25'!
testClassCategories
	self assert: (context categories includesAllOf: self internalCategories).
	self deny: (context categories includesAnyOf: self externalCategories)! !

!OBContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 11:55'!
createFakeD
	Object subclass: #OBFakeClassD
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'OmniBrowser-Fakes'! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:17'!
testMethodCategoryOf
	| ref |
	ref _ MethodReference new setStandardClass: OBFakeClassA methodSymbol: #one.
	self assert: (context methodCategoryOf: ref) = 'numbers'! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/8/2004 12:07'!
testMethodsInCategoryOfClass
	| refs selectors |
	refs _ context methodsInCategory: 'numbers' ofClass: #OBFakeClassA.
	selectors _ refs collect: [:ref | ref methodSymbol].
	self assert: (selectors includesAllOf: #(one two three five))! !

!OBContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 14:42'!
testClasses
	self createFakeD.
	self assertClassExists: #OBFakeClassD.
	context renameClass: #OBFakeClassD toBe: #OBFakeClassE.
	self assertClassExists: #OBFakeClassE.
	self denyClassExists: #OBFakeClassD.
	context removeClass: #OBFakeClassE.
	self denyClassExists: #OBFakeClassE! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:53'!
testClassesInCategory
	self assert: ((context classesInCategory: self fakeCategory)
					 includesAllOf: self fakeClasses).
	! !

!OBContextTest methodsFor: 'asserting' stamp: 'cwp 2/7/2004 12:02'!
assertClassExists: aString
	self assert: (self classExists: aString)! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 13:39'!
testClassCategoryOperations
	context addCategory: 'OBContext-Added'.
	self assert: (context categories includes: 'OBContext-Added').
	context renameCategory: 'OBContext-Added' toBe: 'OBContext-Renamed'.
	self assert: (context categories includes: 'OBContext-Renamed').
	self deny: (context categories includes: 'OBContext-Added').
	context removeCategory: 'OBContext-Renamed'.
	self deny: (context categories includes: 'OBContext-Renamed')
! !

!OBContextTest methodsFor: 'asserting' stamp: 'cwp 2/7/2004 12:02'!
denyClassExists: aString
	self deny: (self classExists: aString)! !

!OBContextTest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 12:36'!
isAbstract
	^ self name = 'OBContextTest'! !

OBContextTest subclass: #OBPackageContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:46'!
fakeAExtensionSelectors
	^ #(foo)! !

!OBPackageContextTest methodsFor: 'running' stamp: 'cwp 2/7/2004 13:33'!
setUp
	context _ OBPackageContext named: 'OmniBrowserFakes'! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:43'!
fakeCategory
	^ 'Fakes'! !

!OBPackageContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 12:37'!
classExists: aString
	^ Smalltalk hasClassNamed: aString! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:27'!
internalCategories
	^ #('Fakes')! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:46'!
fakeACoreSelectors
	^ #(one two three a b)! !

!OBPackageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:27'!
externalCategories
	^ #('Kernel')! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 14:43'!
testMethodCategories
	context addCategory: 'added' toClass: #OBFakeClassB.
	self assert: ((context coreCategoriesForClass: #OBFakeClassB) includes: 'added').
	context renameCategory: 'added' inClass: #OBFakeClassB toBe: 'renamed'.
	self assert: ((context coreCategoriesForClass: #OBFakeClassB) includes: 'renamed').
	self deny: ((context coreCategoriesForClass: #OBFakeClassB) includes: 'added').
	context removeCategory: 'renamed' fromClass: #OBFakeClassB.
	self deny: ((context coreCategoriesForClass: #OBFakeClassB) includes: 'renamed')! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/7/2004 12:30'!
testPackages
	| names |
	names _ context packages collect: [:p | p packageName].
	self assert: (names includes: 'OmniBrowser').! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/9/2004 20:11'!
testCategoryOf
	self assert: (context categoryOf: #OBFakeClassA) = self fakeCategory.
	self assert: (context categoryOf: #'OBFakeClassA class') = self fakeCategory.! !

!OBContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 14:41'!
fakeClasses
	^ #(OBFakeClassA OBFakeClassB OBFakeClassC)! !

!OBContextTest methodsFor: 'testing' stamp: 'cwp 2/9/2004 23:42'!
testMessagesSentByInClass
	| messages |
	messages _ context messagesSentBy: #five inClass: #OBFakeClassA.
	self assert: (messages asSet = #(two + three) asSet)
	! !

OBContextTest subclass: #OBImageContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:31'!
internalCategories
	^ #('OmniBrowser-Kernel' 'OmniBrowser-Nodes' 'OmniBrowser-Actors')! !

!OBImageContextTest methodsFor: 'running' stamp: 'cwp 2/7/2004 12:35'!
setUp
	context _ OBImageContext new! !

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 13:29'!
externalCategories
	^ #()! !

!OBImageContextTest methodsFor: 'queries' stamp: 'cwp 2/7/2004 12:35'!
classExists: aString
	^ Smalltalk hasClassNamed: aString! !

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:48'!
fakeACoreSelectors
	^ #(one two three a b foo)! !

!OBImageContextTest methodsFor: 'fakes' stamp: 'cwp 2/7/2004 12:48'!
fakeAExtensionSelectors
	^ #()! !

!BorderedSubpaneDividerMorph methodsFor: '*omnibrowser' stamp: 'cwp 2/8/2004 00:08'!
idealWidth
	^ 4! !

!Morph methodsFor: '*omnibrowser' stamp: 'cwp 2/8/2004 00:37'!
idealWidth
	^ self allMorphs 
			inject: 0 
			into: [:widest :morph | 
					(morph isKindOf: StringMorph)
						ifTrue: [widest max: (morph measureContents x) + 5]
						ifFalse: [widest]]! !

MessageSend subclass: #OBAction
	instanceVariableNames: 'label monitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBAction methodsFor: 'evaluating' stamp: 'cwp 1/7/2004 18:22'!
perform: aSelector orSendTo: anObject
	^ self perform: aSelector! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:12'!
label: aString
	label _ aString! !

!OBAction class methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 09:20'!
label: aString receiver: anObject selector: aSelector arguments: anArray
	^ (self receiver: anObject selector: aSelector arguments: anArray) label: aString! !

!OBAction methodsFor: 'evaluating' stamp: 'cwp 2/2/2004 21:11'!
trigger
	[self value]
		on: OBNotification
		do: [:aNotification | 
			monitor notification: aNotification. 
			aNotification resume].! !

!OBAction methodsFor: 'morphic' stamp: 'cwp 1/7/2004 09:52'!
addItemToMenu: aMenu
	aMenu
		add: label
		target: self 
		selector: #trigger! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:59'!
monitor: anObject
	monitor _ anObject! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:11'!
label
	^ label! !

Notification subclass: #OBTextRequest
	instanceVariableNames: 'prompt template'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:23'!
prompt: aString
	prompt _ aString! !

!OBTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/2/2004 21:27'!
requestText
	^ FillInTheBlankMorph 
		request: prompt
		initialAnswer: template
		centerAt: Sensor cursorPoint
		inWorld: World
		onCancelReturn: nil
		acceptOnCR: true! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 20:59'!
template: aString
	template _ aString! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:24'!
prompt
	^ prompt! !

!OBTextRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/5/2004 20:31'!
prompt: promptString template: templateString
	^ (self new prompt: promptString; template: templateString) signal! !

!OBTextRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/2/2004 21:27'!
defaultAction
	self resume: self requestText! !

!OBTextRequest methodsFor: 'accessing' stamp: 'cwp 2/2/2004 21:00'!
template
	^ template! !

!OBTextRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/2/2004 21:30'!
prompt: aString
	^ self new prompt: aString; template: ''! !

Notification subclass: #OBNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

OBNotification subclass: #OBNodeDeleted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBNodeDeleted methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:33'!
notify: aMonitor
	aMonitor nodeDeleted! !

OBNotification subclass: #OBNodeSelected
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBNodeSelected methodsFor: 'as yet unclassified' stamp: 'cwp 1/29/2004 23:37'!
node
	^ node! !

!OBNodeSelected methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 17:01'!
notify: aMonitor
	aMonitor nodeCreated: node! !

!OBNodeSelected methodsFor: 'as yet unclassified' stamp: 'cwp 1/29/2004 23:37'!
node: aNode
	node _ aNode! !

!OBNodeSelected class methodsFor: 'as yet unclassified' stamp: 'cwp 1/29/2004 23:37'!
for: aNode
	^ self new node: aNode! !

OBNotification subclass: #OBListChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBListChanged methodsFor: 'as yet unclassified' stamp: 'cwp 1/30/2004 00:33'!
notify: aMonitor
	aMonitor listChanged! !

Notification subclass: #OBChoiceRequest
	instanceVariableNames: 'prompt options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Notifications'!

!OBChoiceRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:31'!
prompt: aString options: anArray
	^ (self new setPrompt: aString options: anArray) signal! !

!OBChoiceRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:30'!
defaultAction
	^ options at: ((PopUpMenu labelArray: options) startUpWithCaption: prompt)
	! !

!OBChoiceRequest class methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:33'!
options: anArray
	^ (self new setOptions: anArray) signal! !

!OBChoiceRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:25'!
setPrompt: aString options: anArray
	prompt _ aString.
	options _ anArray! !

!OBChoiceRequest methodsFor: 'as yet unclassified' stamp: 'cwp 2/9/2004 23:33'!
setOptions: anArray
	options _ anArray! !

Slider subclass: #OBScrollBar
	instanceVariableNames: 'upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay'
	classVariableNames: 'CachedImages UpArrow8Bit UpArrow'
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
extent: p
        p x > p y
                ifTrue: [super extent: (p max: 42@8)]
                ifFalse: [super extent: (p max: 8@42)]! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:07'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton _ upButton.
	upButton bottom > upperBoundsButton bottom
		ifTrue: [upperBoundsButton _ upButton].
	^ bounds isWide
		ifTrue: [upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse: [upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
alternativeScrollbarLook
	^Preferences alternativeScrollbarLook! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDown
	self flag: #obsolete.
	downButton eventHandler: nil.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollDownInit! !

!OBScrollBar methodsFor: 'scroll timing' stamp: 'cwp 11/23/2003 18:07'!
resetTimer
	timeOfMouseDown _ Time millisecondClockValue.
	timeOfLastScroll _ timeOfMouseDown - 1000 max: 0.
	nextPageDirection _ nil.
	currentScrollDelay _ nil! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
scrollDelta
	^ scrollDelta! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:07'!
sliderThickness
	^ self roundedScrollbarLook ifTrue:[15] ifFalse:[super sliderThickness]! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializePagingArea
	pagingArea := RectangleMorph newBounds: self totalSliderArea
								color: (Color r: 0.6 g: 0.6 b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea on: #mouseDown send: #scrollPageInit: to: self.
	pagingArea on: #mouseUp send: #finishedScrolling to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook 
		ifTrue:[pagingArea color: (Color gray: 0.9)].! !

!OBScrollBar methodsFor: 'testing' stamp: 'cwp 11/23/2003 18:06'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollBarAction
	^self valueOfProperty: #scrollBarAction! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeDownButton
	downButton := RectangleMorph
		newBounds: (self innerBounds bottomRight - self buttonExtent extent: self buttonExtent)
		color: self thumbColor.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	downButton addMorphCentered: (ImageMorph new image: 
		(self 
			cachedImageAt: (bounds isWide ifTrue: ['right'] ifFalse: ['down']) 
			ifAbsentPut: [
				self upArrow8Bit
					rotateBy: (bounds isWide ifTrue: [#right] ifFalse: [#pi])
					centerAt: 0@0
			]
		)
	).
	self roundedScrollbarLook ifTrue:[
		downButton color: Color veryLightGray.
		downButton borderStyle: (BorderStyle complexRaised width: 3).
	] ifFalse:[
		downButton setBorderWidth: 1 borderColor: #raised.
	].
	self addMorph: downButton.
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
setNextDirectionFromEvent: event

	nextPageDirection _ bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeEmbedded: aBool
	"aBool == true => inboard scrollbar
	aBool == false => flop-out scrollbar"
	self roundedScrollbarLook ifFalse:[^self].
	aBool ifTrue:[
		self borderStyle: (BorderStyle inset width: 2).
		self cornerStyle: #square.
	] ifFalse:[
		self borderStyle: (BorderStyle width: 1 color: Color black).
		self cornerStyle: #rounded.
	].
	self removeAllMorphs.
	self initializeSlider.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
sliderShadowColor
	^ self roundedScrollbarLook
		ifTrue: [self sliderColor darker]
		ifFalse: [super sliderShadowColor]
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval _ d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!OBScrollBar methodsFor: 'initialization' stamp: 'cwp 11/23/2003 18:07'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self roundedScrollbarLook ifTrue:[
		self borderStyle: ((BorderStyle complexFramed width: 2) "baseColor: Color gray")].! !

!OBScrollBar methodsFor: 'testing' stamp: 'cwp 11/23/2003 18:06'!
wantsSteps
	^self scrollBarAction notNil! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUp
	self flag: #obsolete.
	upButton eventHandler: nil.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollUpInit! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook ifTrue:[
		upButton borderStyle: (BorderStyle complexRaised width: upButton borderWidth).
		downButton borderStyle: (BorderStyle complexRaised width: downButton borderWidth).
	] ifFalse:[
		downButton borderRaised.
		upButton borderRaised.
	].

! !

!OBScrollBar class methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2003 18:07'!
alwaysShowFlatScrollbarForAlternativeLook
	"Set this value to true, if you want to see the flat scrollbar look in flop-out mode as well as inboard.  Otherwise the flop-out scrollbar will be rounded and inboard will be flat."
	^ false! !

!OBScrollBar methodsFor: 'other events' stamp: 'cwp 11/23/2003 18:06'!
mouseDownInSlider: event
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBar].
	super mouseDownInSlider: event! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeSlider
	self roundedScrollbarLook ifTrue:[
		self 
			initializeUpButton;
			initializeDownButton;
			initializePagingArea.
	] ifFalse:[
		self initializeUpButton; 
			initializeDownButton; 
			initializePagingArea.
	].
	super initializeSlider.
	self roundedScrollbarLook ifTrue:[
		slider cornerStyle: #rounded.
		slider borderStyle: (BorderStyle complexRaised width: 3).
		sliderShadow cornerStyle: #rounded.
	].
	self sliderColor: self sliderColor.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta _ d1.
	pageDelta _ d2.! !

!OBScrollBar methodsFor: 'accessing' stamp: 'cwp 11/23/2003 18:06'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	self alternativeScrollbarLook ifFalse:[^self].
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollBarAction: aSymbol
	self setProperty: #scrollBarAction toValue: aSymbol! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeUpButton
	upButton := self roundedScrollbarLook 
				ifTrue:  
					[RectangleMorph 
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
				ifFalse: 
					[RectangleMorph 
						newBounds: ((self innerBounds topLeft) extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton 
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	upButton 
		addMorphCentered: (ImageMorph new image: (self 
						cachedImageAt: (bounds isWide ifTrue: ['left'] ifFalse: ['up'])
						ifAbsentPut: 
							[bounds isWide 
								ifTrue: [self upArrow8Bit rotateBy: #left centerAt: 0 @ 0]
								ifFalse: [self upArrow8Bit]])).
	self roundedScrollbarLook 
		ifTrue: 
			[upButton color: Color veryLightGray.
			upButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton setBorderWidth: 1 borderColor: #raised].
	self addMorph: upButton! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r _ self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: self sliderThickness) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: self sliderThickness)])! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
thumbColor
	"Problem: Part of the ScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self alternativeScrollbarLook 
		ifTrue: [self sliderColor alphaMixed: 0.7 with: (Color gray: 0.95)]
		ifFalse: [Color veryLightGray]! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
pagingArea
	^pagingArea! !

!OBScrollBar methodsFor: 'stepping and presenter' stamp: 'cwp 11/23/2003 18:07'!
step
	| action |
	action _ self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!OBScrollBar methodsFor: 'scroll timing' stamp: 'cwp 11/23/2003 18:07'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!OBScrollBar methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2003 18:06'!
cachedImageAt: aKey ifAbsentPut: aBlock

	CachedImages ifNil: [CachedImages _ Dictionary new].
	^CachedImages at: aKey ifAbsentPut: aBlock! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
roundedScrollbarLook
	"Rounded look currently only shows up in flop-out mode"
	^Preferences alternativeScrollbarLook and: [Preferences inboardScrollbars not and: [self class alwaysShowFlatScrollbarForAlternativeLook not]]
! !

!OBScrollBar methodsFor: 'other events' stamp: 'cwp 11/23/2003 18:06'!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event]! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
buttonExtent
	^ bounds isWide
		ifTrue: [11 @ self innerBounds height]
		ifFalse: [self innerBounds width @ 11]! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
upArrow8Bit

	"convert to 8-bit and convert white to transparent to avoid gratuitous conversion every time we put one in an ImageMorph"

	^UpArrow8Bit ifNil: [
		UpArrow8Bit _ (ColorForm mappingWhiteToTransparentFrom: UpArrow) asFormOfDepth: 8
	]! !

!OBScrollBar class methodsFor: 'class initialization' stamp: 'cwp 11/23/2003 18:07'!
initialize "ScrollBar initialize"

	UpArrow _ Form
		extent: 6@3
		fromArray: #(2r11e28 2r1111e27 2r111111e26)
		offset: 0@0.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
sliderColor: aColor
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor _ self thumbColor.
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor.
	self alternativeScrollbarLook ifTrue:
		[self roundedScrollbarLook
			ifTrue:
				[self color: Color transparent.
				pagingArea color: aColor muchLighter.
				self borderStyle style == #simple 
					ifTrue:[self borderColor: aColor darker darker]
					ifFalse:[self borderStyle baseColor: aColor]]
			ifFalse:
				[pagingArea color: (aColor alphaMixed: 0.3 with: Color white).
				self borderWidth: 0]]
! !

!OBScrollBar methodsFor: 'model access' stamp: 'cwp 11/23/2003 18:06'!
setValue: newValue
	"Using roundTo: instead of truncateTo: ensures that scrollUp will scroll the same distance as scrollDown."
	^ super setValue: (newValue roundTo: scrollDelta)! !

PackageInfo subclass: #OBFakePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:31'!
systemCategoryPrefix
	^ 'OmniBrowser'! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 2/7/2004 13:42'!
systemCategories
	^ (SystemOrganization categories select: [:cat | cat includesSubString: 'OBContext']) 
		copyWith: #'OmniBrowser-Fakes'! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 15:19'!
packageName
	^ 'OmniBrowserFakes'! !

OBFakePackage subclass: #OBFakeImageContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeImageContext methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 14:22'!
packages
	^ Array with: self! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2004 13:56'!
classes
	^ (SystemOrganization listAtCategoryNamed: self systemCategoryPrefix, '-Fakes')
		collect: [:name | Smalltalk at: name].! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 12/14/2003 21:06'!
shortNameOf: aSystemCategoryName
	^ aSystemCategoryName allButFirst: self systemCategoryPrefix size + 1! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 1/29/2004 23:06'!
longNameOf: shortName
	^ self systemCategoryPrefix, '-', shortName
! !
OBBrowser initialize!
OBMetaGraphBuilder initialize!
OBScrollBar initialize!
